#!/usr/bin/perl

#--------ライブラリ読込み------------------------

$commonpl='lib/common.pl';
if(!-e $commonpl){
	&error("$commonplがありません。");
}
require $commonpl;

$common2pl='lib/common2.cgi';
if(!-e $common2pl){
	&error("$common2plがありません。");
}
require $common2pl;

$functionspl='lib/functions.pl';
if(!-e $functionspl){
	&error("$functionsplがありません。");
}
require $functionspl;

if(!-e $passlog){
	&error("passlogがありません。");
}
require $passlog;

#-------変数-------------------------------------

$maxsize='1000000';
$t_size='10pt';
$t_color='#000000';
$l_color='#0000ff';
$b_color='#ffffff';
$c_valid='365';
@avoid=('<table','<td','<tr','<meta','<form','<embed','script','<style','<body','<!--','<link','<input','style *=','<object','frame','on[a-zA-Z ]+=','expression');

#-------------------------------------------------


$FORM{'page'}=0;

&Deco;

sub Deco{
my($name,$value,$buff,@pairs,$pair,$d,$n);

if($ENV{'REQUEST_METHOD'} eq "POST"){
	if($ENV{'CONTENT_LENGTH'} > $maxsize){
		&error("投稿量が多すぎます。");
	}
	read(STDIN,$buff,$ENV{'CONTENT_LENGTH'});
}
else{
	$buff=$ENV{'QUERY_STRING'};
}

if($buff){
	@pairs=split(/&/,$buff);
	foreach $pair(@pairs){
		($name,$value)=split(/=/,$pair);
		$value=~tr/+/ /;
		$value=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("H2",$1)/eg;
		$value=~s/&/&amp;/g;
		$value=~s/,/&#44;/g;
		$value=~s/'/&#039;/g;
		$value=~s/</&lt;/g;
		$value=~s/>/&gt;/g;
		$value=~s/"/&quot;/g;
		if($name eq "message" || $name =~/^comment/ || $name eq "header" || $name eq "footer"){
			$value=~s/\x0D\x0A/<br>/g;
			$value=~s/\x0D/<br>/g;
			$value=~s/\x0A/<br>/g;
		}
		else{
			$value=~s/\x0D\x0A//g;
			$value=~s/\x0D//g;
			$value=~s/\x0A//g;
		}

		if($name eq "delnum"){
			push(@delnum,$value);
		}
		elsif($name=~/^order_/){
			($d,$n)=split(/_/,$name);
			$ORDER{$n}=$value;

		}
		elsif($name=~/^op_/){
			if($value){
				push @OP,$value;
			}
		}
		elsif($name eq 'kai'){
			if($value){
				push @KAI,$value;
			}
		}
		$FORM{$name}=$value;
	}
}

}


if($ENV{'SCRIPT_NAME'}){
	$c_name=$ENV{'SCRIPT_NAME'};
}
else{
	$c_name="admin";
}

if($FORM{'mode'}=~/^mailfo/){
	if(!-e 'lib/mailfo.pl'){
		&error('mailfo.plがありません。');
	}
	require 'lib/mailfo.pl';
}

elsif($FORM{'mode'}=~/^env/){
	if(!-e 'lib/set.pl'){
		&error('set.plがありません。');
	}
	require 'lib/set.pl';
}

if($FORM{'mode'} eq "menu"){
	&Menu;
}
elsif($FORM{'mode'} eq "mailfo"){
	&MailFo;
}
elsif($FORM{'mode'} eq "mailfoform"){
	&MailFoForm;
}
elsif($FORM{'mode'} eq "mailfoedit"){
	&MailFoForm('edit');
}
elsif($FORM{'mode'} eq "mailfocheck"){
	&MailFoCheck;
}
elsif($FORM{'mode'} eq "mailforegist"){
	&MailFoRegist;
}
elsif($FORM{'mode'} eq "mailfodel"){
	&MailFoDel;
}
elsif($FORM{'mode'} eq "mailfoeditregist"){
	&MailFoEditRegist;
}
elsif($FORM{'mode'} eq "mailfokomoku"){
	&MailFoKomoku;
}
elsif($FORM{'mode'} eq "mailfokomokuregist"){
	&MailFoKomokuRegist;
}
elsif($FORM{'mode'} eq "mailfokomokudel"){
	&MailFoKomokuDel;
}
elsif($FORM{'mode'} eq "mailfokomokuedit"){
	&MailFoKomokuEdit;
}
elsif($FORM{'mode'} eq "mailfokomokueditregist"){
	&MailFoKomokuEditRegist;
}
elsif($FORM{'mode'} eq "mailfokomokuorder"){
	&MailFoKomokuOrder;
}
elsif($FORM{'mode'} eq "env"){
	&Env;
}
elsif($FORM{'mode'} eq "envregist"){
	&EnvRegist;
}
elsif($FORM{'mode'} eq "meru"){
	&Meru;
}
elsif($FORM{'mode'} eq "meruform"){
	&MeruForm;
}
else{
	&Login;
}

sub GetCookie{
my($name,$value,$pair,@pairs,$cookies);
$cookies=$ENV{'HTTP_COOKIE'};
@pairs=split(/;/,$cookies);
foreach $pair(@pairs){
	($name, $value)=split(/=/,$pair);
	$name=~s/ //g;
	$DUMMY{$name}=$value;
}
$DUMMY{$c_name}=~ s/\+/ /g;
$DUMMY{$c_name}=~ s/%([0-9A-Fa-f][0-9A-Fa-f])/pack("C", hex($1))/eg;
@pairs=split(/,/,$DUMMY{$c_name});
foreach $pair(@pairs){
	($name, $value)=split(/\:/,$pair);
	$COOKIE{$name}=$value;
}
}

sub SetCookie{
my($secg,$ming,$hourg,$mdayg,$mong,$yearg,$wdayg,$ydayg,$isdstg,
$timer,$date_gmt,$cook,@month,@week,
);
$timer=time;
($secg, $ming, $hourg, $mdayg, $mong, $yearg, $wdayg, $ydayg, $isdstg)=gmtime($timer+$c_valid*24*60*60);
@month=('Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec');
@week=('Sun','Mon','Tue','Wed','Thu','Fri','Sat');
$date_gmt=sprintf("%s, %02d\-%s\-%04d %02d:%02d:%02d GMT",$week[$wdayg],$mdayg,$month[$mong],$yearg+1900,$hourg,$ming,$secg);
$cook="pass:$FORM{'pass'}";
$cook=~s/([^\w\=\& ])/'%' . unpack("H2", $1)/eg;
$cook=~tr/ /+/;
print "Set-Cookie: $c_name=$cook; expires=$date_gmt\n";
}

sub DelCookie{
print "Set-Cookie: $c_name=;\n";
}

sub CheckPass{
my($fopass,$passflag);
if($passwd eq ""){
	&error("パスワードが設定されていません。");
}
$fopass=$_[0];
if($passwd eq 'admin'){
	if($fopass ne $passwd){
		&error("パスワードが違います。");
	}
}
else{
	$passflag=&MatchPass($fopass,$passwd);
	if(!$passflag){
		&error("パスワードが違います。");
	}
}
return;
}


sub Login{
my($ck,$ok);
&GetCookie;

if($COOKIE{'pass'}){
	$ck=" checked";
	$ok="1";
}

&header;

print <<EOM;
<body>
<br>
<br>
<br>
<div align=center>
<form method="POST" action="">
<input type="hidden" name="mode" value="menu">
<input type="hidden" name="ok" value="$ok">
<table>
<tr>
<td>パスワード</td>
<td><input size="8" type="password" name="pass" maxlength="8" value="$COOKIE{'pass'}"></td>
<td><input type="submit" value="ログイン"></td>
</tr>
<tr>
<td></td>
<td><input type="checkbox" name="cookie" value="1"$ck>クッキー</td>
<td></td>
</table>

</form>
</div>
</body>
</html>
EOM
exit;

}

sub Menu{

&CheckPass($FORM{'pass'});

if(!$FORM{'ok'} && $FORM{'cookie'}){
	&SetCookie;
}
elsif($FORM{'ok'} && !$FORM{'cookie'}){
	&DelCookie;
}


&header;

print <<EOM;
<body>
<p>
<a href="?mode=login">ログインへ</a></p>
<div align=center>
<table width="450" border="0" cellspacing="2" cellpadding="0">
<tr> 
<td align=center class="obi"><b><font color="#ffffff">機能\の選択</font></b></td>
</tr>
</table>
機能\を選んでボタンを押してください。
<br><br>
<table cellpadding=4 width=450 class="settbl">
<tr>
<td height=40>
<form action="" method="POST" style="margin:0px">
<input type="hidden" name="mode" value="mailfo">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type=submit name="menu" value="メールフォーム" style="width:150px">
</form>
</td><td>メールフォームの作成と削除と編集を行います。</td>
</tr>
<tr>
<td height=40>
<form action="" method="POST" style="margin:0px">
<input type="hidden" name="mode" value="env">
<input type="hidden" name="pass" value="$FORM{'pass'}">
<input type=submit name="menu" value="環境設定" style="width:150px">
</form>
</td><td>パスワードなどの設定を行います。</td>
</tr>
</table>

</div>
</body>
</html>
EOM
exit;

}


sub encode{
my(@saltset,$salt,$newcode);
@saltset=('a'..'z','A'..'Z','0'..'9');
srand(time^$$);
$salt=$saltset[int(rand(@saltset))].$saltset[int(rand(@saltset))];
eval{$newcode=crypt($_[0],$salt);};
if($@){
	&error("暗号化の関数がサポートされていないのでこのサーバーでは使えません。");
}
if($newcode=~/^\$1\$/){
	$newcode=crypt($_[0],'$1$');
}
return $newcode;
}

sub MatchPass{
my($pass,$coded,$salt,$passflag);
$pass=$_[0];
$coded=$_[1];
$passflag=0;
if($coded=~/^\$1\$/){
	if(crypt($pass,'$1$') eq $coded){
		$passflag=1;
	}
}
else{
	$salt=substr($coded,0,2);
	if(crypt($pass,$salt) eq $coded){
		$passflag=1;
	}
}
return $passflag;
}



sub header{
print <<EOM;
Content-type: text/html

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title>管理用</title>
<style type="text/css">
<!--
body{
color: ${t_color};
background-color: ${b_color};
font-family: "ＭＳ Ｐゴシック";
}
p,td,li,div{
font-size: ${t_size};
}
a{
color: ${l_color};
/*text-decoration:none;*/
}
.tb{
border-style:solid;
border-color:#999999;
border-width:1px;
}
.line{
border-color:#999999;
border-style:dashed;
height:1px;
}
.pad{
padding:4px 0px 0px 4px;
}

.settbl{ 
border:1px solid #999999;
border-collapse:collapse;
background-color:#F3F3F3;
}
.settbl td{ 
border:1px solid #999999;
border-collapse:collapse;
}

.bg{
background-color:#eeeeee;
}

.komoku{
background-color:#e0e0e0;
}
.obi{
background-color:#999999;
}

.komoku{
background-color:#e0e0e0;
}

.noline{
border:none;
}
.noline td{
border:none;
}
-->
</style>
<script type="text/javascript">

function openwin(win,w,h){
var features="toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes,top=0,left=0,"+"width="+w+",height="+h;
window.open(win,"s_win",features);
}

function Edit(n){
document.editfo.no.value=n;
document.editfo.submit();

}

function FoCheck(){
var e="";

if(document.fo.fno.value == ""){
	e+="IDが入力されていません。\\n";
}
var tmp=document.fo.fno.value;
if(tmp.match(/[^0-9a-zA-Z_]+/)){
	e+="※IDに半角英数字以外が含まれています。\\n";
}
if(document.fo.name.value == ""){
	e+="フォーム名が入力されていません。\\n";
}
if(document.fo.title.value == ""){
	e+="メールのタイトル(管理者へのメール)が入力されていません。\\n";
}
if(document.fo.title2.value == ""){
	e+="メールのタイトル(相手へのメール)が入力されていません。\\n";
}
if(document.fo.mailto.value == ""){
	e+="メールアドレスが入力されていません。\\n";
}

if(e){
	alert(e);
	return false;
}

}


function MailFoEdit(no){
document.editfo.editnum.value=no;
document.editfo.submit();

}

function MailFoKomoku(n){
document.kofo.fno.value=n;
document.kofo.submit();
}

function MailFoKomokuOrder(){
var tmp=document.fo.mode.value;
document.fo.mode.value='mailfokomokuorder';
document.fo.submit();
document.fo.mode.value=tmp;
}

function MailFoKomokuEdit(n){
document.editfo.editnum.value=n;
document.editfo.submit();
}

function KoCheck(){
var e="";
if(document.kofo.komoku.value == ""){
	e+="項目名が入力されていません。\\n";
}
var flag=false;
for(i=0;i<document.kofo.kind.length;i++){
	if(document.kofo.kind[i].checked == true){
		flag=true;
		break;
	}
}
if(!flag){
	e+="フォームの種類が選択されていません。\\n";
}


if(e){
	alert(e);
	return false;
}

}

function AddIn(){
	var ob = document.getElementById('se');
	ob.style.display='block';
}
function SubmitIn(n,a){
	var mo;
	if(a == 'edit'){
		mo='mailfokomokuedit';
	}
	else{
		mo='mailfokomoku';
	}
	document.kofo.num.value=n;
	document.kofo.mode.value=mo;
	document.kofo.act.value='in';
	document.kofo.submit();
}

EOM

if($_[0]){
print <<EOM;
function Alert(a){
alert(a);
}
EOM
$on=" onload=\"Alert('$_[0]')\"";
}

print <<EOM;
</script>
</head>
EOM
}



sub error{


&header;
print <<EOM;
<body>
<br>
<br>
<p align="center"><font color="#ff0000">ERROR</font><br><br>
EOM
print"$_[0]\n";
print <<EOM;
</p>
<p align="center">
EOM

print <<EOM;
</p>
</body>
</html>
EOM
exit;
}
exit;